Ameba::Rule::Performance::Base - ameba 1.7.0

# abstract class Ameba::Rule::Performance::Base

- Ameba::Rule::Performance::Base
- Ameba::Rule::Base
- Reference
- Object

##
Overview

A general base class for performance rules.

##
Included Modules

- YAML::Serializable

##
Direct Known Subclasses

- Ameba::Rule::Performance::AnyAfterFilter
- Ameba::Rule::Performance::AnyInsteadOfEmpty
- Ameba::Rule::Performance::AnyInsteadOfPresent
- Ameba::Rule::Performance::ChainedCallWithNoBang
- Ameba::Rule::Performance::CompactAfterMap
- Ameba::Rule::Performance::ExcessiveAllocations
- Ameba::Rule::Performance::FirstLastAfterFilter
- Ameba::Rule::Performance::FlattenAfterMap
- Ameba::Rule::Performance::MapInsteadOfBlock
- Ameba::Rule::Performance::MinMaxAfterMap
- Ameba::Rule::Performance::SizeAfterFilter
- Ameba::Rule::Performance::TimesMap

##
Defined in:

ameba/rule/performance/base.cr

##
Constructors

- .new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)
- .new(config = nil)

  A general base class for performance rules.

- .new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node)

##
Class Method Summary

- .deprecated?

  Returns `true` if this rule is deprecated, `false` otherwise.

- .deprecation_reason : String | Nil

  Returns the deprecation reason for this rule, if there is any.

- .documentation_url : String

  Returns the documentation URL for this rule.

- .parsed_doc : String | Nil

  Returns the documentation for this rule, if there is any.

##
Instance Method Summary

- #catch(source : Source)

  A convenient addition to `#test` method that does the same but returns a passed in `source` as an addition.

### Instance methods inherited from class `Ameba::Rule::Base`

==(other : self) ==, catch(source : Source) catch, excluded?(source, root = Dir.current) excluded?, group group, hash(hasher) hash, name name, special? special?, test(source : Source, node : Crystal::ASTNode, *opts)
test(source : Source) test

### Class methods inherited from class `Ameba::Rule::Base`

default_severity : Ameba::Severity default_severity, group_name group_name, rule_name rule_name

### Macros inherited from class `Ameba::Rule::Base`

issue_for(*args, **kwargs, &block) issue_for

### Macros inherited from module `Ameba::Config::RuleConfig`

properties(&block) properties

##
Constructor Detail

def self.new(ctx : YAML::ParseContext, node : YAML::Nodes::Node) #
def self.new(config = nil) #

A general base class for performance rules.

def self.new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node) #

##
Class Method Detail

def self.deprecated? #

Returns `true` if this rule is deprecated, `false` otherwise.

def self.deprecation_reason : String | Nil #

Returns the deprecation reason for this rule, if there is any.

def self.documentation_url : String #

Returns the documentation URL for this rule.

    Ameba::Rule::Lint::Syntax.documentation_url
    # => "https://crystal-ameba.org/api/master/Ameba/Rule/Lint/Syntax.html"

def self.parsed_doc : String | Nil #

Returns the documentation for this rule, if there is any.

    module Ameba
      # This is a test rule.
      # Does nothing.
      class Rule::MyRule < Rule::Base
        def test(source)
        end
      end
    end

    Ameba::Rule::MyRule.parsed_doc # => "This is a test rule.\nDoes nothing."

##
Instance Method Detail

def catch(source : Source) #
Description copied from class Ameba::Rule::Base

A convenient addition to `#test` method that does the same but returns a passed in `source` as an addition.

    source = MyRule.new.catch(source)
    source.valid?